/**
 * PETALS - PETALS Services Platform. Copyright (c) 2008 EBM Websourcing,
 * http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.ow2.petals.registry.core.gms;

import org.ow2.petals.registry.api.LocalRegistry;
import org.ow2.petals.registry.api.lifecycle.LifeCycle;

/**
 * TODO : The GMS manager is in charge of accepting peers and sending message to
 * subscribe to other peers. TODO : Add strategies for accepting join/leave
 * request like in the message propagation.
 * 
 * @author Christophe HAMERLING - eBM WebSourcing
 * 
 */
public interface GMSManager extends LifeCycle {

    /**
     * Join a group
     * 
     * @param remoteRegistry
     */
    void join(Group group);

    /**
     * Quit a group
     * 
     * @param remoteRegistry
     */
    void quit(Group group);

    /**
     * 
     * @return
     */
    LocalRegistry getLocalRegistry();

}
