/*
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package org.ow2.petals.registry.core.ws.adapters;

import javax.xml.transform.TransformerException;

import org.ow2.petals.registry.api.Endpoint;
import org.ow2.petals.registry.api.util.XMLUtil;
import org.ow2.petals.registry.api.ws.adapters.EndpointAdapter;

/**
 * @author Christophe HAMERLING - eBM WebSourcing
 * 
 */
public class EndpointAdapterImpl implements EndpointAdapter {

    public EndpointAdapterImpl() {
    }

    /**
     * {@inheritDoc}
     */
    public Endpoint toRegistryEndpoint(org.ow2.petals.registry.api.ws.to.Endpoint endpoint) {
        Endpoint result = new Endpoint();
        result.setDescription(XMLUtil.createDocumentFromString(endpoint.getServiceDescription()));
        result.setName(endpoint.getName());
        result.setProperties(endpoint.getProperties());
        result.setInterfaces(endpoint.getInterfaces());
        result.setService(endpoint.getService());
        return result;
    }

    /**
     * {@inheritDoc}
     */
    public org.ow2.petals.registry.api.ws.to.Endpoint toWSEndpoint(Endpoint endpoint) {
        org.ow2.petals.registry.api.ws.to.Endpoint result = new org.ow2.petals.registry.api.ws.to.Endpoint();
        result.setName(endpoint.getName());
        result.setProperties(endpoint.getProperties());
        try {
            if (endpoint.getDescription() != null) {
                result.setServiceDescription(XMLUtil.createStringFromDOMDocument(endpoint
                        .getDescription()));
            }
        } catch (TransformerException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        result.setInterfaces(endpoint.getInterfaces());
        result.setService(endpoint.getService());
        return result;
    }

}
